Subject: [bess] RTG Dir QA review: draft-ietf-l3vpn-end-system-requirements-00.txt

From: Ross Callon <[email-masked]>
Date: Fri, 7 Nov 2014 02:58:26 +0000

Hello,

I have been selected as the Routing Directorate QA reviewer for draft-ietf-l3vpn-end-system-requirements-00.txt

The Routing Directorate QA reviews are intended to be a support to improve the quality of RTG Area documents as they pass through the IETF process. This is the QA review at the time of the WG document adoption poll.

Summary

This document serves a useful purpose in clarifying the requirements for extending BGP/MPLS to support virtual end systems, such as might be found in a data center environment.  As such it seems a good companion to the solutions drafts and appropriate as a WG document. I am assuming that the chairs and AD will know whether this should be reissued as draft-ietf-bess-end-system-requirements-00.txt or perhaps as draft-ietf-bess-l3vpn-end-system-requirements-00.txt.

I believe that the technical contents of this document are excellent. The document however contains a significant number of minor grammatical issues, ranging from nits to minor editorial issues. Given the large number of such grammatical issues I believe that the document should be updated before it will be ready for WGLC.

Comments

>From a technical point of view I believe that the document is useful, sound and well written. The rest of these comments is a long list of grammatical nits and suggested improvements.

Abstract, second sentence: "Virtualized end-system environment imposes additional requirements to MPLS/BGP VPN technology". For correct English this should be either "The virtualized end-system environment imposes additional requirements to MPLS/BGP VPN technology" or "Virtualized end-system environments impose additional requirements to MPLS/BGP VPN technology". Personally I would have a slight preference for the latter.

Introduction, first paragraph, fourth sentence: "This is referred as server, storage, and network virtualization". I think that this should be "This is referred to as server, storage, and network virtualization".

Introduction, first paragraph, last sentence. This currently reads "Compute nodes running guest operating systems are often executed as Virtual Machines (or VMs)". Is it well known what is meant by a "guest operating system"? For me at least this could use some clarification.

Introduction, third paragraph, last sentence: "The solutions may referred as End-System solutions or virtual PE (vPE) solutions in different documents". This should be "The solutions may be referred to in other documents as End-System solutions or virtual PE (vPE) solutions".

Section 1.1 (Terminology), first paragraph. This reads:

    The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
    "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
    document are to be interpreted as described in RFC 2119 [RFC2119].

This paragraph is redundant with the earlier "Requirements Language" section and should be removed.

Section 2, first sentence: "MPLS/BGP VPN technology [RFC4364] have proven to be able to..." should be
either "MPLS/BGP VPN technology [RFC4364] has proven to be able to..."
or "MPLS/BGP VPNs [RFC4364] have proven to be able to...".

Section 2, first paragraph, second sentence: "In traditional WAN deployments of BGP IP VPNs a Customer Edge (CE) is a physical device,
residing a customer's location, connected to a Provider Edge (PE), residing in a Service Provider's location.". Do you mean "In traditional WAN
deployments of BGP IP VPNs a Customer Edge router (CE) is a physical device, residing a customer's location, connected to a Provider Edge router (PE), residing in a Service Provider's location."?

Section 2.1, first paragraph: "When end-system attaches to MPLS/BGP VPN, CE corresponds to a non-routing host that can reside in a Virtual Machine or be an application residing on the end-system itself". Do you mean "When an end-system attaches to an MPLS/BGP VPN, the CE may correspond to a non-routing host that can reside in a Virtual Machine or may be an application residing on the end-system itself"? In section 1.1 you listed the acronym "CE" as being short for "CE router". In this case, if the CE is not a router, then isn't the acronym wrong? Do you want the acronym "CE" for "customer edge equipment", and "CER" for "customer edge router"? Alternately, in 1.1 should "CE" be an acronym for "customer edge device (either router or end system)"?

Section 2.1, in the second paragraph you use the term "transport network infrastructure". It seems to me that this seems to refer to something other than what is normally meant by "transport network infrastructure". Do you mean "core routers in the service provider network", or "data center routers"? I see however that you are however consistent in the way that you use "transport network". Perhaps you should explain this term up front. It is possible that your use of the term is common and that this use is okay.

Section 2.1, third paragraph, second sentence: "In such deployments PE may be..." should be "In such deployments the PE may be...".

Section 2.2, second paragraph, first sentence. This currently reads:

    In end-system environment, a single end-system, effectively, corresponds to a line card in a traditional PE router.

I am not sure what the word "effectively" is doing in this sentence.

Section 3.1, first sentence: "A network virtualization solution should be able to provide IPv4 and IPv6 unicast connectivity between hosts in the same and different subnets without any assumptions regarding the underlying media layer". I think that this would be a bit cleaner if written "A network virtualization solution should be able to provide IPv4 and IPv6 unicast connectivity between hosts in the same subnet or in different subnets without any assumptions regarding the underlying media layer".

Section 3.2, first sentence: "Furthermore, the multicast transmission,...". This should be "Furthermore multicast transmission,...". Also, I believe that there should be a comma immediately after "IPv6 addresses".

Section 3.3, fourth sentence: "End-system network virtualization solution should be able to provide...". This should be either "The end-system network virtualization solution should be able to provide..." or "End-system network virtualization solutions should be able to provide...".

Section 4, bullet items: The first three of these do not start with a sentence, the fourth does start with a sentence. For correct parallel grammar they either should all start with a sentence or none of them should. Also, the sentence which is the fourth bullet item again has either a word "An" missing from the front, or "end-point" should be plural ("end-points").

Section 4, last paragraph (after the bullets): "End-system network virtualization solution should support...".  Again, this should be either "The end-system network virtualization solution should support..." or "End-system network virtualization solutions should support...".

Section 7, third paragraph, last sentence. There is an extra or mis-placed comma, "with both, internal..." should be "with both internal...".

Section 7.1, first sentence. There is a word missing: "MPLS/VPN technology based on [RFC4364] specifies that different encapsulation methods could be for connecting PE routers,..." should be "MPLS/VPN technology based on [RFC4364] specifies that different encapsulation methods could be used for connecting PE routers,...".

Section 7.1, third paragraph: I think that "MPLS-in-IP" and "MPLS-In-GRE" are normally hyphenated.  I think that "Due to route aggregation property of IP protocols" should be "Due to the route aggregation property of IP protocols".

Section 9, first paragraph, end of last sentence, again a "the" is missing. "...is an effective way to solve IP mobility problem" should be "...is an effective way to solve the IP mobility problem".

Section 9, second paragraph, first sentence: "IP mobility consists in a device physically moving..." should be "IP mobility consists of a device physically moving...".   Second sentence, again a "the" is missing. Second sentence should start: "IP mobility requires preserving the device's active network connections...".

Section 9.3, second paragraph, first sentence. This currently reads:

    To minimize the disruption to established communication during  workload or device mobility,
    the control plane of a network virtualization solution should be able to differentiate between
    the activation of a workload in a new location from advertizing its route to the network.

I can't figure out what this sentence is supposed to say. Thus I can't propose alternate wording but you should look at it carefully. The following sentence is again missing a "the", as in "prior to the workload's migration".

Section 10, first paragraph, second sentence: Again "the" is missing, as in "virtualized resources in the SP's data center". The next sentence "and" is missing, as in "... and wireless connectivity".

Section 10, right after the list of bullets the rest of this section is still indented. I suspect that you need to fiddle with XML2RFC or other source format to get this lined up correctly. First paragraph after the bullets, second sentence is again missing "the", as in "... the VPN's IP routing information".

Section 11.1, again this is missing a "a" or "the", as in "BGP was designed to carry a very large amount of ...".

Section 11.1.1, first paragraph, third sentence. The beginning of this sentence is a bit off. I suggest that you change "These techniques allow to forward traffic almost continuously using ..." to "These techniques allow traffic to be forwarded almost continuously using ...".

Section 12, third paragraph is awkward. I would suggest changing this to "One solution that has been proposed in the IETF is [I-D.rfernando-l3vpn-service-chaining]".

Section 12.1, second paragraph, first sentence has an unnecessary comma after the word "both". This should be: "Load balancing should support deployments where both virtual and physical service appliances are present.".

Section 12.2, second paragraph, first sentence. I think that you should change "It is a requirement that service chaining solution satisfies the requirements of symmetric forward/reverse paths for flows and a minimal traffic disruption when service instances are added to or removed from a set of instances." to be "It is a requirement that the service chaining solution satisfies the requirements of symmetric forward/reverse paths for flows and for a minimal traffic disruption when service instances are added to or removed from a set of instances.".

The First section 13 (security considerations), first bullet item: This says "End-systems MPLS/BGP VPNs solution". Does it mean " The end-system's MPLS/BGP VPNs solution", or does this mean "The MPLS/BGP VPN solution used in end systems"?

The second Section 13 (IANA Considerations): Given that this is the second section 13 in the document, there is apparently an error in the formatting. Also, in one version both section 13's have titles that are not in bold (unlike other section headers), which I expect is part of the same formatting issue (although they are both in bold in a different version of the document, argh).

That is all. Thanks!  Ross

---

From: Luyuan Fang <[email-masked]>
Date: Tue, 11 Nov 2014 20:07:58 +0000

Hi Ross,

Thank you very much for your review and detailed comments, we really appreciate!
We are going to first reissue the draft as BESS working group doc 00 version as it is for book keeping purpose, then address all your comments in the 01 version.

Thanks,
Luyuan

From: Ross Callon [mailto:[email-masked]]
Sent: Thursday, November 6, 2014 4:58 PM
To: BRUNGARD, DEBORAH A; [email-masked]; Luyuan Fang
Cc: [email-masked]; Ross Callon; EXT - [email-masked]; 'Martin Vigoureux' ([email-masked])
Subject: RTG Dir QA review: draft-ietf-l3vpn-end-system-requirements-00.txt

Hello,

Summary

Comments